/*

Copyright (C) 2011 Caffeinated Code <http://caffeinatedco.de>
Copyright (C) 2011 Jono Cooper
Copyright (C) 2011 George Czabania
This program is free software: you can redistribute it and/or modify it 
under the terms of the GNU General Public License version 3, as published 
by the Free Software Foundation.

This program is distributed in the hope that it will be useful, but 
WITHOUT ANY WARRANTY; without even the implied warranties of 
MERCHANTABILITY, SATISFACTORY QUALITY, or FITNESS FOR A PARTICULAR 
PURPOSE.  See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along 
with this program.  If not, see <http://www.gnu.org/licenses/>.

*/

//DEFINE OS HERE!
// windows, macApp, macSource, linux

os = 'linux';

//Sets donate text differently for different OSes

$(document).ready(function() {
	if (os == 'linux') {
		$('#donatetext').html('If our first computers were Mac&#8217;s and not Dell&#8217;s we would charge you $5 for this app.<br><br>However since we love free software, Gradiator is open source and you can help some poor students by donating.<br>');
	} else if (os == 'macApp' || os == 'macSource') {

		$('#about').remove();
		$('#settingsHelpBTN').remove();

		if (os == 'macApp') {
			$('#donateBTN').html('css');
			$('#donatesend').remove();
			$('#donate .button').css({'display': 'block', 'margin': '0 auto'});
			$('#donatetext').css({'font-family': 'Monaco, monospace', 'font-size': '10px'});
		} else if (os == 'macSource') {
			$('#donatetext').html('The Mac version of Gradiator was created on a borrowed single core MacBook. The animations are even laggy.<br><br>Please support Gradiator by purchasing it in the Mac App Store or donating.<br>')
		};
	};
});

// Caching selectors
var $slider = $('#slider'),
	gradient = {
		$preview: $('#preview'),
		$final: $('#final'),
		direction: 'top'
	},
	details = {
		$position: $('#position .number, #positionCFG'),
		$colour: $('#color .number'),
		$opacity: $('#alpha .number, #alphaCFG'),
	},
	// Width of slider
	max = $slider.width(),
	// create stops object that holds current stop and an array of all the stops
	stops = {
		current: 0,
		items: [[0,"rgb(186, 218, 85)",100],[60,"rgb(125, 173, 75)",100] ,[100,"rgb(64, 128, 64)",100]]
	},
	// variables for the slider to be dragged
	n = 1,
	dragok = false, 
	x,d,dx;

// Clone multidimensional arrays
Array.prototype.clone = function() {
	var arr = this.slice(0);
	for( var i = 0; i < this.length; i++ ) {
		if( this[i].clone ) {
			arr[i] = this[i].clone();
		}
	}
	return arr;
}

// Takes an rgb or rgba color and returns the red/green/blue/alpha information
function split_color(color) {
	switch(get_type_of_color(color)) {
		case "rgba":
			var	_rgba = /^rgba?\((\d+),\s*(\d+),\s*(\d+)(?:,\s*(0\.\d+))?\)$/.exec(color),
			red = parseInt(_rgba[1]), green = parseInt(_rgba[2]), blue = parseInt(_rgba[3]), alpha = parseFloat(_rgba[4]);
			return [red, green, blue, alpha]
			break;
		case "rgb":
			var	_rgb = /(.*?)rgb\((\d+),\s*(\d+),\s*(\d+)\)/.exec(color),
			red = parseInt(_rgb[2]), green = parseInt(_rgb[3]), blue = parseInt(_rgb[4]);
			return [red, green, blue, 1];
			break;
	}
}

// Checks if is rgba
function get_type_of_color(color) {
	switch(color.substr(0,4)) {
		case "rgba":
			return('rgba');
			break;
		case "rgb(":
			return('rgb');
			break;
	}
}

/*
This awesome function will take two colors, the positions of those colors and the position on the chosen color and
then return the proportional blend of those colors. If iterated through it would produce a gradient!

_min: 	RGB of first colour 		rgb(40, 100, 230)
_max: 	RGB of second colour		rgb(20, 50, 210)
_min_x: position of _min 			0
_max_x: position of _max			100
_x: 	position of blended colour 	50
*/
function blend(_min, _max, _min_x, _max_x, _x) {
	var	_min = split_color(_min),
		_max = split_color(_max),
		_percent = Math.abs(1 / ((_max_x - _min_x) / (_x - _min_x))),
		_percent_inverse = 1 - _percent,
		_blend = {
			red: Math.round((_min[0] * _percent_inverse) + (_max[0] * _percent)),
			green: Math.round((_min[1] * _percent_inverse) + (_max[1] * _percent)),
			blue: Math.round((_min[2] * _percent_inverse) + (_max[2] * _percent)),
			alpha: Math.round(((_min[3] * _percent_inverse) + (_max[3] * _percent)) * 100) / 100
		};
	if(_blend.alpha == 1) {
		return "rgb(" + _blend.red + "," + _blend.green + "," + _blend.blue + ")";
	} else if(_blend.alpha == 0) {
		return "rgba(" + _blend.red + "," + _blend.green + "," + _blend.blue + "," + _blend.alpha + ".0)";
	} else {
		return "rgba(" + _blend.red + "," + _blend.green + "," + _blend.blue + "," + _blend.alpha + ")";
	}
}

// Load stops from array
function load() {
	$.each(stops.items, function(index, data) {
		$slider.append('<div class="stop ' + index + '">').find('.stop.' + index).css({'background-image': '-webkit-linear-gradient(' + data[1] + ',' + data[1] + '), url(img/grid.png)', 'background-image': '-webkit-gradient(linear, left top, left bottom, from(' + data[1] + '), to(' + data[1] + ')), url(img/grid.png)', 'left': data[0]*max/100});
	});
	$('.stop.' + stops.current).addClass('current');
}

// Remove colour stop from slider and array
function removeStop() {
	stops.items.splice(stops.current, 1); // remove stop from array
	$('.stop').remove();
	load();
	$('#slider .current').removeClass('current');
	$('#gradientDetails div').addClass('disabled')
	preview_gradient();
	clear_details();
}

// Set the opacity of a colour stop
function opacity(_opacity) {
	var	$current = $('#slider .current');
	_color = split_color(stops.items[stops.current][1]);
	if(_opacity < 100) {
		if(_opacity == 0) {
			_opacity = '0.0'
		} else {
			_opacity /= 100;
		}
		_color = "rgba(" + _color[0] + ", " + _color[1] + ", " + _color[2] + ", " + _opacity + ")";
	} else {
		_opacity = 1;
		_color = "rgb(" + _color[0] + ", " + _color[1] + ", " + _color[2] + ")";
	}
	stops.items[stops.current][1] = _color;
	stops.items[stops.current][2] = _opacity*100;
	preview_gradient();
	update_details();
	$current.css({'background': "-webkit-linear-gradient(left, " + _color + "0%, " + _color + " 100%), url(img/grid.png)", 'background': '-webkit-gradient(linear, left top, left bottom, from(' + _color + '), to(' + _color + ')), url(img/grid.png)'});
}

// Set the position of a colour stop
function position(_position) {
	var $current = $('#slider .current');
	stops.items[stops.current][0] = _position;
	preview_gradient();
	$current.css('left', _position/100*max);
}

// Sort stops by location
function sort_stops() {
	var line, _temp = stops.items.clone();
		_temp.sort(function(a, b) {
			if(a[0] > b[0]) {
				return 1
			} else if (a[0] < b[0]) {
				return -1
			} else {
				return 0;
			}
		});
	return _temp;
}

function legacy_direction(dir) {
	//TIL Legacy directions are really fucking dumb.
	if (dir == 'top') {
		return "left top, left bottom, ";
	} else if (dir == 'left') {
		return "left top, right top, ";
	} else if (dir == 'bottom') {
		return "left bottom, left top, ";
	} else if (dir == 'right') {
		return "right top, left top, ";
	} else if (dir == 'left top') {
		return "left top, right bottom, ";
	} else if (dir == 'left bottom') {
		return "left bottom, right top, ";
	} else if (dir == 'right bottom') {
		return "right bottom, left top, ";
	} else if (dir == 'right top') {
		return "right top, left bottom, "
	}
};

// Calculate the gradient and display it in the gradient window
function preview_gradient() {


	var _temp = sort_stops(),
		preview = "-webkit-linear-gradient(left, ",
		previewLegacy = "-webkit-gradient(linear, left top, right top, ",
		final = "-webkit-linear-gradient(" + gradient.direction + ", ",
		finalLegacy = "-webkit-gradient(linear, " + legacy_direction(gradient.direction);
	for(var _i = 0; _i < _temp.length; _i++) {
		if(_i != _temp.length-1) {
			line = _temp[_i][1] + " " + _temp[_i][0] + "%, ";
			lineLegacy = "color-stop(" + _temp[_i][0]/100 + "," + _temp[_i][1] + "), ";
			preview += line;
			previewLegacy += lineLegacy;
			final += line;
			finalLegacy += lineLegacy;
		} else {
			line = _temp[_i][1] + " " + _temp[_i][0] + "%), url(img/grid.png)";
			lineLegacy = "color-stop(" + _temp[_i][0]/100 + "," + _temp[_i][1] + ")) , url(img/grid.png)";
			preview += line;
			previewLegacy += lineLegacy;
			final += line;
			finalLegacy += lineLegacy;
		}
	}
	gradient.$preview.css({'background': preview, 'background': previewLegacy});
	gradient.$final.css({'background': final, 'background': finalLegacy});
}

function get_browser_prefix() {
	var _browsers = [];
	// Loop through each prefix checkbox in the settings
	for(var _i = 0; _i < $('#prefix .prefix').length; _i++) {
		// Cache the current checkbox
		var _prefix = $('#prefix .prefix')[_i];
		// Check if it is checked
		if(_prefix.checked) {
			// If it is, add its data-name to the _browsers array
			_browsers.push($(_prefix).attr('data-name'));
		}
	}
	// Return which browser prefixes are selected
	return _browsers;
}

// Convert array items into a lovely vendor prefixed CSS.
function calculate_gradient_code() {
	// Variables
	var _prefix = [],
		_stops = "";
		_legacy_stops = "";
		_items = sort_stops(),
		_output = "";
	// Run get_browser_prefix() and generate the prefix code based on which browser prefixes have been selected
	$.each(get_browser_prefix(), function(_i, _data) {
		// If the data-name is 'css3' then use the unprefixed code
		if(_data == "css3") {
			_prefix.push("linear-gradient(" + gradient.direction + ", ");
		//If the data name is 'legacywebkit', we have to use an entirely different syntax =(
		} else if (_data == 'legacywebkit') {
			_prefix.push("-webkit-gradient(linear, " + legacy_direction(gradient.direction));
		// Else just add extra code around it to create the prefix
		} else {
			_prefix.push("-" + _data + "-linear-gradient(" + gradient.direction + ", ");
		}
	});
	// Only run if at least one browser was selected
	if(_prefix.length > 0) {

		// Loop through each color stop for normal syntax
		for(var _i = 0; _i < _items.length; _i++) {
			// Check whether the color stop is transparent, if it isn't convert it to hex
			get_type_of_color(_items[_i][1]) == "rgba" ? _color = _items[_i][1] : _color = colorConvert(_items[_i][1], 'hex');
			// Append the color stop to the browser prefix
			if(_i != _items.length-1) {
				_stops += _color + " " + _items[_i][0] + "%, ";
			// If it is the last stop ommit the comma and add a semi-colon
			} else {
				_stops += _color + " " + _items[_i][0] + "%);";
			}
		}

		// Loop through each color stop for LEGACY WEBKIT SYNTAX
		for(var _i = 0; _i < _items.length; _i++) {
			// Check whether the color stop is transparent, if it isn't convert it to hex
			get_type_of_color(_items[_i][1]) == "rgba" ? _color = _items[_i][1] : _color = colorConvert(_items[_i][1], 'hex');
			// Append the color stop to the browser prefix
			if(_i != _items.length-1) {
				_legacy_stops += "color-stop(" + _items[_i][0]/100 + ", " + _color + "), ";
			// If it is the last stop ommit the comma and add a semi-colon
			} else {
				_legacy_stops += "color-stop(" + _items[_i][0]/100 + ", " + _color + "));";
			}
		}


		// Loop through each browser prefix and append the prefix and stops to the output
		for(var _x = 0; _x < _prefix.length; _x++) {

			if (_prefix[_x] == "-webkit-gradient(linear, " + legacy_direction(gradient.direction)) {
				_output += "background: " + _prefix[_x] + _legacy_stops + "<br>";
			} else {
				_output += "background: " + _prefix[_x] + _stops + "<br>";
			};
			
		}		
	// Else output this warning
	} else {
		_output = "You haven't selected any browser prefixes - change the settings!";
	}
	return _output;
}


// Dragging a colour stop
function move(e) {
	if (!e) e = window.event;
	if (dragok) {
		// Calculating position to move
		var left = dx + e.clientX - x;
		// Restricting min/max to edges of the slider
		if(left < 0) left = 0;
		if(left > max) left = max;
		// Updating position
		d.style.left = left + "px";
		// Updating stop.items array with percentage value of displacement
		stops.items[stops.current][0] = Math.round(left/max*100);
		// Display real-time gradient
		preview_gradient();
		// Updating details (location)
		details.$position.val(stops.items[stops.current][0]);
		return false;
	}
}

// Clicking and holding a colour stop
function down(e) {
	if (!e) e = window.event;
	var temp = (typeof e.target != "undefined")?e.target:e.srcElement;
	if (temp.tagName != "HTML"|"BODY" && !$(temp).hasClass('stop')){
		temp = (typeof temp.parentNode != "undefined")?temp.parentNode:temp.parentElement;
	}
	if ($(temp).hasClass('stop')){
		//Blurs Color Box
		$('#colorCFG input').blur();
		// Show that it is selected by highlighting it
		$('#slider .current').removeClass('current');
		$(temp).addClass('current');
		// Set current stop to class name of selected stop
		stops.current = parseInt( $('#slider .current').attr('class').split(/\s+/)[1]);
		// Enable disabled buttons
		$('#alpha, #color, #position, #colorCFG, #colorCFG div').removeClass('disabled')
		if(stops.items.length > 2) $('#delete').removeClass('disabled')
		// Update details (location, colour, opacity)
		update_details();
		// Slider code
		dragok = true;
		temp.style.zIndex = n++;
		d = temp;
		dx = parseInt(temp.style.left+0);
		x = e.clientX;
		document.onmousemove = move;
		return false;
	}
}

// Releasing a colour stop
function up() {
	dragok = false;
	document.onmousemove = null;
}

function replaceColor(_color) {
	
	if(_color) { // If color was chosen

		if (stops.items[stops.current][2] < 100) {
			var value = colorConvert(_color, 'rgb');
			_color = 'rgba(' + value.substring(4, value.length - 1) + ',' + stops.items[stops.current][2] / 100 + ')';
		}

		// Create a new element #temp and set the background to the chosen color
		$('body').append('<div id="temp">').find('#temp').css('background', _color);
		// Then get the color of the #temporary element. This is returned in RGB format
		_color = $('#temp').css('background-color');
		// Remove #temp
		$('#temp').remove();
		// Update the array
		stops.items[stops.current][1] = _color;
		// Update the color stop. A gradient is used to enable multiple backgrounds for the transparency grid
		$('#slider .current').css({"background": "-webkit-linear-gradient(left, " + _color + "0%, " + _color + " 100%), url('img/grid.png')", 'background': '-webkit-gradient(linear, left top, left bottom, from(' + _color + '), to(' + _color + ')), url(img/grid.png)'});
		// Update gradient
		preview_gradient();
		update_details();
	}				
}

// If user clicks the slider, create a new stop at that position
$slider.mouseup(function(e) {
	if(!dragok) {
		var _x = Math.round((e.clientX - $(this).offset().left)/max*100), // position of new stop
			_item_number = stops.items.length, // caching length of array
			_min = [-1, 'null'], _max = [101, 'null'];
		// Find the two stops on the immediate left/right of where the user clicked
		for(var _i = 0; _i < _item_number; _i++) {
			if(stops.items[_i][0] > _min[0] && stops.items[_i][0] < _x) {
				_min[0] = stops.items[_i][0];
				_min[1] = _i;
			}
			if(stops.items[_i][0] < _max[0] && stops.items[_i][0] > _x) {
				_max[0] = stops.items[_i][0];
				_max[1] = _i;
			}
		}
		// If the user clicked on the far right/left of the slider then just use the color on the opposite side
		if(_min[1] == 'null') {
			_color = stops.items[_max[1]][1];
		} else if (_max[1] == 'null') {
			_color = stops.items[_min[1]][1];
		// Else blend the colors together
		} else {
			_color = (blend(stops.items[_min[1]][1], stops.items[_max[1]][1], stops.items[_min[1]][0], stops.items[_max[1]][0], _x));
		}
		// Create a new stop and select it
		$('#slider .current').removeClass('current');
		$slider.append('<div class="stop ' + _item_number + ' current">').find('.current').css({'background':  "-webkit-linear-gradient(left, " + _color + "0%, " + _color + " 100%), url('img/grid.png')", 'background': '-webkit-gradient(linear, left top, left bottom, from(' + _color + '), to(' + _color + ')), url(img/grid.png)', 'left': _x/100*max});
		stops.current = _item_number;
		// Add the stop to the array
		stops.items.push([_x, _color, split_color(_color)[3]*100]);
		// Load the gradient
		preview_gradient();
		update_details();
		// If any buttons were disabled, enable them as a stop is now selected and there are more than two stops
		$('.disabled').removeClass('disabled');
	}
});

// Displays details about the current stop (position, colour, opacity)
function update_details() {
	details.$position.val(stops.items[stops.current][0]);
	colorBoxes();
	details.$colour.html(colorConvert(stops.items[stops.current][1], 'hex'));
	details.$opacity.val(stops.items[stops.current][2]);
	$('#alphaCFG').css({'background': '-webkit-linear-gradient(left, transparent, ' + colorConvert(stops.items[stops.current][1], 'hex') + '),  url("img/gridsmall.png")', 'background': '-webkit-gradient(linear, left top, right top, from(transparent), to(' + colorConvert(stops.items[stops.current][1], 'hex') + ')),  url("img/gridsmall.png")'});
}

// Clear details
function clear_details() {
	details.$position.value = '';
	details.$colour.val(stops.items[stops.current][1]);
	details.$opacity.value = 100;
}

// Changing the direction of the gradient
$('#direction div').click(function() {
	// Change current direction
	$('#direction .current').removeClass('current')
	// Get class of chosen direction and set it as the gradients direction
	gradient.direction = $(this).attr('class');
	// Set chosen direction as current direction
	$(this).addClass('current');
	// Update gradient
	preview_gradient();
});


// Load stops from array
load();
// Load gradient
preview_gradient();
update_details();
document.onmousedown = down;
document.onmouseup = up;

/* Range Sliders
 * TODO: Refactor */

$('#alphaCFG').on("change", function() {
	var value = $(this).val();
	$('#alpha .number').val(value);
	opacity(value);
});

$('#positionCFG').on("change", function() {
	var value = $(this).val();
	$('#position .number').val(value);
	position(value);
});

/* Text Box changes range slider
 * TODO: Refactor */
$('#alpha .number').on("keyup", function() {
	var value = $(this).val();

	if (value != '') {
		$('#alphaCFG').val(value);
		opacity(value);	
	}
});

$('#position .number').on("keyup", function() {
	var value = $(this).val();
	//Restricts between 0 & 100
	if (value > 100) value = 100; 
	if (value < 0) value = 0;
	$('#position .number').val(value);
	$('#positionCFG').val(value);
	position(value);
});

//Color Box thing
$('#colorCFG #hexInput').on('keyup', function() {
	var value = colorConvert($(this).val(), 'rgb');
	if (value != undefined) {

		//Converts to RGBA if opacity < 100
		if (stops.items[stops.current][2] < 100) {
			replaceColor('rgba(' + value.substring(4, value.length - 1) + ',' + stops.items[stops.current][2] / 100 + ')');
		} else {
			replaceColor(value);
		};
	};
});

$('#colorCFG #rgbInput input').on('keyup', function() {
	if ($('#rgbInput .0').val() != '' && $('#rgbInput .1').val() != '' && $('#rgbInput .2').val() != '') {
		var value = colorConvert('rgb(' + $('#rgbInput .0').val() + ',' + $('#rgbInput .1').val() + ',' + $('#rgbInput .2').val() + ')', 'rgb');
		if (value != undefined) {

			//Converts to RGBA if opacity < 100
			if (stops.items[stops.current][2] < 100) {
				replaceColor('rgba(' + value.substring(4, value.length - 1) + ',' + stops.items[stops.current][2] / 100 + ')');
			} else {
				replaceColor(value);
			};
		};
	};
});

//HSL Craps it's pants.
$('#colorCFG #hslInput input').on('change', function() {
	if ($('#hslInput .0').val() != '' && $('#hslInput .1').val() != '' && $('#hslInput .2').val() != '') {

		var value = colorConvert('hsl(' + $('#hslInput .0').val() + ',' + $('#hslInput .1').val() + ',' + $('#hslInput .2').val() + ')', 'rgb');
		if (value != undefined) {

			//Converts to RGBA if opacity < 100
			if (stops.items[stops.current][2] < 100) {
				replaceColor('rgba(' + value.substring(4, value.length - 1) + ',' + stops.items[stops.current][2] / 100 + ')');
			} else {
				replaceColor(value);
			};
		};
	};
});

//Closes all modal dialogs on esc
$(document).keyup(function(e) {
	if (e.keyCode == 27) { 
		$('#overlay').click(); 
	} 
});

//Closes all modal dialogs on click
$('#overlay, .close').click(function() {
	$('#overlay').hide(0);
	$('.modal').slideUp(150);
})

$('#donateBTN').click(function() {
	if (os == 'macApp') {
		$('#donatetext').html(calculate_gradient_code());
	};
	
	$('#donate').slideDown(150);
	$('#overlay').show(0);
});

$('#settingsBTN').click(function() {
	$('#settings').slideDown(150);
	$('#overlay').show(0);
});


//Modal Buttons
$('#gradientDetails div, #copyBTN').click(function(){

	
	if ($(this).hasClass('selected')) {
		$(this).removeClass('selected').html('remove<br>stop');
		if(stops.items.length <= 2) $('#delete').addClass('disabled');
		$('#alphaCFG, #positionCFG, #colorCFG').fadeOut(200);
		$('#alpha, #color, #position').delay(250).animate({width:'show'},200);


	} else {

		//Get the id of this clicked item
		var type = $(this).attr('id');

		if (type == 'alpha' || type == 'position' || type == 'color') {

			if ($(this).hasClass('disabled')) {
				//Do nothing
			} else {

				$(this).children().focus();
				$('#delete').removeClass('disabled').addClass('selected').html('save<br>changes');

				if (type == 'alpha') {

					$('#color, #position').animate({width:'hide'},200);
					$('#alphaCFG').delay(250).fadeIn(200);
	
				} else if (type == 'position') {

					$('#alpha, #color').animate({width:'hide'},200);
					$('#positionCFG').delay(250).fadeIn(200);

				} else if (type == 'color') {

					$('#alpha, #color, #position').animate({width:'hide'},200);
					$('#colorCFG').delay(250).fadeIn(200);
				};
			};

		} else if (type == 'delete') {

			if(!$(this).is('.disabled')) removeStop();

		} else if (type == 'copyBTN') {

			$('#code').html(calculate_gradient_code());
			send('copy', $("#code").html());
			$('#copy').slideDown(150).delay(1500).slideUp(150);

		} else if (type == 'picker') {

			if(!$(this).is('.disabled')) send('color', colorConvert(stops.items[stops.current][1], 'hex'));
		};

	};

});


//Needs to be refactored.
function colorConvert(input, colorSpace) {

	//Strips spaces
	input = input.replace( /\s/g, "" );

	//Converts RGBA to RGB
	if (input.match('^rgba\\(')) {
		input = input.substring(5, input.length - 1);
		rgb = input.split(',');

		input = "rgb(" + rgb[0] + "," + rgb[1] + "," + rgb[2] + ")";
	};

	if (input.match('^#[0-f]{6}') || input.match('^#[0-f]{3}')) {
		
		input = input.substring(1, input.length);

		var longhex = input;

		if (input.length == 3) {

			//I'm too lazy to use a loop
			longhex = input[0].replace(input[0], input[0] + input[0]);
			longhex += input[1].replace(input[1], input[1] + input[1]);
			longhex += input[2].replace(input[2], input[2] + input[2]);
		};

		if (colorSpace == 'rgb' || colorSpace == 'hsl') {

			var rgb = new Array;

			rgb[0] = parseInt(longhex.substring(0,2),16);
			rgb[1] = parseInt(longhex.substring(2,4),16);
			rgb[2] = parseInt(longhex.substring(4,6),16);

			//Checks if it is a number
			rgb[0] = isNaN(rgb[0]) ? 0 : rgb[0];
			rgb[1] = isNaN(rgb[1]) ? 0 : rgb[1];
			rgb[2] = isNaN(rgb[2]) ? 0 : rgb[2];

			if (colorSpace == 'rgb') {
				return "rgb(" + rgb[0] + "," + rgb[1] + "," + rgb[2] + ")";
			} else if (colorSpace == 'hsl') {
				
				var hsl = rgb2Hsl(rgb[0], rgb[1], rgb[2]);
				return 'hsl(' + hsl[0] + ',' + hsl[1] + '%,' + hsl[2] + '%)'
			};

		} else if (colorSpace == 'hex') {
			return "#" + longhex;	
		};

	} else if (input.match('^rgb\\(')) {

		//Rips out the rgb bit
		input = input.substring(4, input.length - 1);
		var rgb = input.split(',');

		if (colorSpace == 'rgb') {
			return 'rgb(' + rgb[0] + "," + rgb[1] + "," + rgb[2] + ")";
		} else if (colorSpace == 'hex') {
			
			var i = 0;

			while (i < 3) {

				//Converts Decimal to Hex
				rgb[i] = parseInt(rgb[i], 10).toString(16);

				//So we have a full 6 digit hex code
				if (rgb[i].length == 1) {
					rgb[i] = 0 + rgb[i];	
				};

				i++;
			};			

			return '#' + rgb[0] + rgb[1] + rgb[2];
		} else if (colorSpace == 'hsl') {
			var hsl = rgb2Hsl(rgb[0], rgb[1], rgb[2]);
			return 'hsl(' + hsl[0] + ',' + hsl[1] + '%,' + hsl[2] + '%)'
		};
	} else if (input.match('^hsl\\(')) {

		if (colorSpace == 'hsl') {
			return input;
		} else if (colorSpace == 'rgb' || colorSpace == 'hex') {
			input = input.replace( /%/g, "" );
			input = input.substring(4, input.length - 1);
			hsl = input.split(',');

			//Converts to RGB
			rgb = hsl2Rgb(hsl[0], hsl[1], hsl[2]);

			//Rounds number
			rgb[0] = Math.round(rgb[0]);
			rgb[1] = Math.round(rgb[1]);
			rgb[2] = Math.round(rgb[2]);

			if (colorSpace == 'rgb') {
				return 'rgb(' + rgb[0] + "," + rgb[1] + "," + rgb[2] + ")";
			} else if (colorSpace == 'hex') {
				
				var i = 0;

				while (i < 3) {

					//Converts Decimal to Hex
					rgb[i] = parseInt(rgb[i], 10).toString(16);

					//So we have a full 6 digit hex code
					if (rgb[i].length == 1) {
						rgb[i] = 0 + rgb[i];	
					};

					i++;
				};			

				return '#' + rgb[0] + rgb[1] + rgb[2];
			};
		};
	};

	/*Random HSL Functions*/
	function hsl2Rgb(h, s, l) {
		var m1, m2, hue;
		var r, g, b
		s /=100;
		l /= 100;
		if (s == 0)
			r = g = b = (l * 255);
		else {
			if (l <= 0.5)
				m2 = l * (s + 1);
			else
				m2 = l + s - l * s;
			m1 = l * 2 - m2;
			hue = h / 360;
			r = hue2Rgb(m1, m2, hue + 1/3);
			g = hue2Rgb(m1, m2, hue);
			b = hue2Rgb(m1, m2, hue - 1/3);
		}
		return [r, g, b];
	}
	function hue2Rgb(m1, m2, hue) {
		var v;
		if (hue < 0)
			hue += 1;
		else if (hue > 1)
			hue -= 1;

		if (6 * hue < 1)
			v = m1 + (m2 - m1) * hue * 6;
		else if (2 * hue < 1)
			v = m2;
		else if (3 * hue < 2)
			v = m1 + (m2 - m1) * (2/3 - hue) * 6;
		else
			v = m1;

		return 255 * v;
	}

	function rgb2Hsl(r, g, b){
	    r /= 255, g /= 255, b /= 255;
	    var max = Math.max(r, g, b), min = Math.min(r, g, b);
	    var h, s, l = (max + min) / 2;

	    if(max == min){
	        h = s = 0; // achromatic
	    }else{
	        var d = max - min;
	        s = l > 0.5 ? d / (2 - max - min) : d / (max + min);
	        switch(max){
	            case r: h = (g - b) / d + (g < b ? 6 : 0); break;
	            case g: h = (b - r) / d + 2; break;
	            case b: h = (r - g) / d + 4; break;
	        }
	        h /= 6;
	    }

	    return [Math.floor(h * 360), Math.floor(s * 100), Math.floor(l * 100)];
	}
};

function colorBoxes() {
	var color = stops.items[stops.current][1];

	//Shows in UI
	if ($('#hexInput').is(":focus")) {
	} else {
		$('#hexInput').val(colorConvert(color, 'hex'));
	};

	var i = 0;

	//RGBness
	var str = colorConvert(color, 'rgb')
	str = str.substring(4, str.length - 1);
	var rgb = str.split(',');

	while (i < 3) {
		if ($('#rgbInput .' + i).is(":focus")) {
		} else {
			$('#rgbInput .' + i).val(rgb[i])
		}
		i++;
	}

	i = 0;

	//HSLness
	var str = colorConvert(color, 'hsl')
	str = str.replace( /%/g, "" );
	str = str.substring(4, str.length - 1);
	var hsl = str.split(',');

	while (i < 3) {
		if ($('#hslInput .' + i).is(":focus")) {
		} else {
			$('#hslInput .' + i).val(hsl[i])
		}
		i++;
	}


};

$('#gradientDetails #colorCFG nav ul li').click(function() {
	var id = ($(this).attr('id')).substring(0, 3);

	$('#gradientDetails #colorCFG nav ul li').removeClass('selected');
	$(this).addClass('selected');

	if (id == 'hex') {
		$('#hexInput').delay(150).fadeIn(150);
		$('#rgbInput, #hslInput').fadeOut(150)
	} else if (id == 'rgb') {
		$('#rgbInput').delay(150).fadeIn(150);
		$('#hexInput , #hslInput').fadeOut(150)
	} else if (id == 'hsl') {
		$('#hslInput').delay(150).fadeIn(150);
		$('#hexInput, #rgbInput').fadeOut(150)
	}
	
});

function send(str1, str2) {
	if (os == 'linux') {
		/* Python Bridge */
		document.title = "null"
    	document.title = str1 + "|" + str2;
	} else if (os == 'macApp' || os == 'macSource') {
		/* Objective-C Bridge */
		Cocoa.log(str1 + "|" + str2);
	} else if (os == 'windows') {
		/* Add .net bridge */
	}
}